#include <stdlib.h>
#include <string.h>
#include "pedigree.h"

struct pedigree {
   char* name;
   struct pedigree* father;
   struct pedigree* mother;
};

pedigree* create_node(char* name, pedigree* father, pedigree* mother) {
   pedigree* p = malloc(sizeof(pedigree));
   if (!p) return 0;
   p->name = strdup(name);
   p->father = father; p->mother = mother;
   return p;
}

const char* get_name(pedigree* p) {
   return p->name;
}

pedigree* get_father(pedigree* p) {
   return p->father;
}

pedigree* get_mother(pedigree* p) {
   return p->mother;
}

void set_father(pedigree* child, pedigree* father) {
   child->father = father;
}

void set_mother(pedigree* child, pedigree* mother) {
   child->mother = mother;
}

void free_pedigree(pedigree* p) {
    if (p->father) free_pedigree(p->father);
    if (p->mother) free_pedigree(p->mother);
    free(p->name);
    free(p);
}
